@ ECHO off > \dev\nul
  ECHO MAKE  V2.03  Copyright (C) 1997 by Caldera Inc.
  ECHO  Batchjob to create OpenDOS IBMBIO.COM BIOS kernel file.
  REM Modified by MPAUL 97-09-23
  REM - More detailed messages.
  REM - Now also runs with newer versions of MASM (5.10 tested), because
  REM   %masm% variable has been replaced by %m_asm%, which is not conflictive.
  REM - Allows for a more real make (checking some dependencies) giving optional
  REM   token MAKE as 1st parameter (with 4DOS/NDOS only), e.g. by typing
  REM   MAKE MAKE at the prompt, else just builds the files as usual.
  REM   Three assumptions:
  REM   1. Always run a full build (no MAKE token), if you changed something
  REM      in any of the .EQU and .DEF files, or if you copy files over
  REM      existing files (e.g. other language modules).
  REM   2. To correctly recognize changes in source files, at least one
  REM      minute must have been passed between subsequent builds.
  REM   3. Your system's CMOS clock must be reliable.
  REM - Allows for partial assembly by giving the filename as parameter,
  REM   e.g. by typing MAKE INITMSGS.ASM (just to see, if it compiles...).
  REM - Prepared for FIXUPBIO.EXE (for MS Windows95 dual-boot support).
  REM - Better runs with 4DOS (in low environment situations).

  SET tools=c:\tools

  REM %masm% is a reserved variable for MASM, and shouldn't be used elsewere...
  SET m_asm=%tools%\masm.exe
  SET link=%tools%\link.exe
  SET libr=%tools%\lib.exe

  REM
  REM YOU SHOULD NOT HAVE TO CHANGE ANYTHING BELOW THIS LINE.
  REM

  REM Define local Caldera tools
  SET loctools=..\ltools

  IF NOT EXIST .\bin\nul MD bin> \dev\nul

  REM Check if tools exist

  ECHO Checking for %m_asm%
  IF NOT EXIST %m_asm% GOTO badtool
  ECHO Checking for %link%
  IF NOT EXIST %link% GOTO badtool
  ECHO Checking for %libr%
  IF NOT EXIST %libr% GOTO badtool


  REM *************************************
  REM Build .ASM files first, get the obj's
  REM *************************************

  REM If you have a reliable CMOS clock, you can change this by making
  REM the "MAKE" option the default, and introducing a new "BUILD" token...
  SET make=
  IF NOT "4"=="%@Eval[2 + 2]%" GOTO start
  IF NOT "make"=="%1" IF NOT "Make"=="%1" IF NOT "MAKE"=="%1" GOTO start
  SET make=1
  SHIFT
  :start
  IF NOT ""=="%1" GOTO %1

  :initmsgs.asm
  IF "1"=="%make%" IF EXIST .\bin\initmsgs.obj IF %@FileAge[initmsgs.asm]% LE %@FileAge[.\bin\initmsgs.obj]% GOTO biosmsgs.asm
@ %m_asm% /t /dDRDOS35=0 initmsgs.asm,.\bin\initmsgs.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO INITMSGS.ASM ok
  IF NOT ""=="%1" GOTO exit

  :biosmsgs.asm
  IF "1"=="%make%" IF EXIST .\bin\biosmsgs.obj IF %@FileAge[biosmsgs.asm]% LE %@FileAge[.\bin\biosmsgs.obj]% GOTO init.asm
@ %m_asm% /t biosmsgs.asm,.\bin\biosmsgs.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO BIOSMSGS.ASM ok
  IF NOT ""=="%1" GOTO exit

  :init.asm
  IF "1"=="%make%" IF EXIST .\bin\init.obj IF %@FileAge[init.asm]% LE %@FileAge[.\bin\init.obj]% GOTO clock.asm
@ %m_asm% /t /dDRDOS35=0 init.asm,.\bin\init.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO INIT.ASM ok
  IF NOT ""=="%1" GOTO exit

  :clock.asm
  IF "1"=="%make%" IF EXIST .\bin\clock.obj IF %@FileAge[clock.asm]% LE %@FileAge[.\bin\clock.obj]% GOTO console.asm
@ %m_asm% /t clock.asm,.\bin\clock.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO CLOCK.ASM ok
  IF NOT ""=="%1" GOTO exit

  :console.asm
  IF "1"=="%make%" IF EXIST .\bin\console.obj IF %@FileAge[console.asm]% LE %@FileAge[.\bin\console.obj]% GOTO disk.asm
@ %m_asm% /t console.asm,.\bin\console.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO CONSOLE.ASM ok
  IF NOT ""=="%1" GOTO exit

  :disk.asm
  IF "1"=="%make%" IF EXIST .\bin\disk.obj IF %@FileAge[disk.asm]% LE %@FileAge[.\bin\disk.obj]% GOTO serpar.asm
@ %m_asm% /t disk.asm,.\bin\disk.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO DISK.ASM ok
  IF NOT ""=="%1" GOTO exit

  :serpar.asm
  IF "1"=="%make%" IF EXIST .\bin\serpar.obj IF %@FileAge[serpar.asm]% LE %@FileAge[.\bin\serpar.obj]% GOTO biosgrps.asm
@ %m_asm% /t serpar.asm,.\bin\serpar.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO SERPAR.ASM ok
  IF NOT ""=="%1" GOTO exit

  :biosgrps.asm
  IF "1"=="%make%" IF EXIST .\bin\biosgrps.obj IF %@FileAge[biosgrps.asm]% LE %@FileAge[.\bin\biosgrps.obj]% GOTO stacks.asm
@ %m_asm% /t biosgrps.asm,.\bin\biosgrps.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO BIOSGRPS.ASM ok
  IF NOT ""=="%1" GOTO exit

  :stacks.asm
  IF "1"=="%make%" IF EXIST .\bin\stacks.obj IF %@FileAge[stacks.asm]% LE %@FileAge[.\bin\stacks.obj]% GOTO confstub.a86
@ %m_asm% /t stacks.asm,.\bin\stacks.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO STACKS.ASM ok
  IF NOT ""=="%1" GOTO exit

  REM ******************************************
  REM Build the library so that we can link into
  REM ******************************************
  :confstub.a86
  IF "1"=="%make%" IF EXIST .\bin\confstub.obj IF %@FileAge[confstub.a86]% LE %@FileAge[.\bin\confstub.obj]% GOTO conf_bdos
  GOTO conf_stub

  :conf_bdos
  IF EXIST .\bin\bdosstub.obj IF %@FileAge[bdosstub.a86]% LE %@FileAge[.\bin\bdosstub.obj]% GOTO biosinit.a86
  GOTO bdosstub.a86

  :conf_stub
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\confstub.a86 .\bin\confstub.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO
  ECHO CONFSTUB.A86 ok
  IF NOT ""=="%1" GOTO exit
@ %loctools%\fixupp .\bin\confstub.obj
  IF ERRORLEVEL 1 GOTO failed
  ECHO Fixup ok
  IF NOT ""=="%1" GOTO exit

  :bdosstub.a86
  IF "1"=="%make%" IF EXIST .\bin\bdosstub.obj IF %@FileAge[bdosstub.a86]% LE %@FileAge[.\bin\bdosstub.obj]% GOTO bdos_conf
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\bdosstub.a86 .\bin\bdosstub.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
  ECHO BDOSSTUB.A86 ok
@ %loctools%\fixupp .\bin\bdosstub.obj
  IF ERRORLEVEL 1 GOTO failed
  ECHO Fixup ok
  IF NOT ""=="%1" GOTO exit

  :bdos_conf
@ %libr% .\bin\biosstub.LIB -+ .\bin\bdosstub.obj -+ .\bin\confstub.obj;
  IF ERRORLEVEL 1 GOTO failed
  ECHO Building LIBR ok

  REM ******************************************
  REM Build the .A86 files next, get the obj's
  REM ******************************************
  :biosinit.a86
  IF "1"=="%make%" IF EXIST .\bin\biosinit.obj IF %@FileAge[biosinit.a86]% LE %@FileAge[.\bin\biosinit.obj]% GOTO config.a86
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\biosinit.a86 .\bin\biosinit.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\fixupp .\bin\biosinit.obj
  IF ERRORLEVEL 1 GOTO failed
  IF NOT ""=="%1" GOTO exit

  :config.a86
  IF "1"=="%make%" IF EXIST .\bin\config.obj IF %@FileAge[config.a86]% LE %@FileAge[.\bin\config.obj]% GOTO bdosldr.a86
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\config.a86 .\bin\config.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\fixupp .\bin\config.obj
  IF ERRORLEVEL 1 GOTO failed
  IF NOT ""=="%1" GOTO exit

  :bdosldr.a86
  IF "1"=="%make%" IF EXIST .\bin\bdosldr.obj IF %@FileAge[bdosldr.a86]% LE %@FileAge[.\bin\bdosldr.obj]% GOTO genercfg.a86
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\bdosldr.a86 .\bin\bdosldr.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\fixupp .\bin\bdosldr.obj
  IF ERRORLEVEL 1 GOTO failed
  IF NOT ""=="%1" GOTO exit

  :genercfg.a86
  IF "1"=="%make%" IF EXIST .\bin\genercfg.obj IF %@FileAge[genercfg.a86]% LE %@FileAge[.\bin\genercfg.obj]% GOTO nlsfunc.a86
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\genercfg.a86 .\bin\genercfg.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\fixupp .\bin\genercfg.obj
  IF ERRORLEVEL 1 GOTO failed
  IF NOT ""=="%1" GOTO exit

  :nlsfunc.a86
  IF "1"=="%make%" IF EXIST .\bin\nlsfunc.obj IF %@FileAge[nlsfunc.a86]% LE %@FileAge[.\bin\nlsfunc.obj]% GOTO bios
@ %loctools%\rasm_sh %loctools%\rasm86.exe . .\nlsfunc.a86 .\bin\nlsfunc.obj $szpz /dDRDOS35=0 /dADDDRV=0
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\fixupp .\bin\nlsfunc.obj
  IF ERRORLEVEL 1 GOTO failed
  IF NOT ""=="%1" GOTO exit

  REM ***************************************************
  REM Link the OBJ's and LIBR file to create the BIOS.EXE
  REM and then use EXE2BIN to create the IBMBIO.COM file.
  REM ***************************************************
  :bios
@ %link% @bios.lnk
  IF ERRORLEVEL 1 GOTO failed
@ %loctools%\exe2bin.exe .\bin\bios.exe .\bin\ibmbio.com
  IF ERRORLEVEL 1 GOTO failed
  DEL .\bin\bios.exe > \dev\nul
  REM COPY .\bin\ibmbio.com .\bin\ibmbio.bak > \dev\nul
@ %loctools%\compbios .\bin\ibmbio.com
  IF ERRORLEVEL 1 GOTO failed

  REM Reserved for FIXUPBIO.EXE to patch IBMBIO.COM to support
  REM MS Windows95 dual-boot...
  REM @ %loctools%\fixupbio .\bin\ibmbio.com .\bin\ibmbio.com
  REM IF ERRORLEVEL 1 GOTO failed

  IF NOT "4"=="%@Eval[2 + 2]%" GOTO exit

  IF 29706 GE %@FileSize[.\bin\ibmbio.com,b]% GOTO exit
  ECHO The IBMBIO.COM file may be too large to boot it successfully!
  GOTO exit

  :failed
  ECHO Error in Build!
  GOTO exit

  :badtool
  ECHO Can't find that tool!

  :exit
  REM *********
  REM CLEANUP
  REM *********

  SET make=
  SET tools=
  SET loctools=
  SET m_asm=
  SET tasm=
  SET link=
  SET libr=
